com.gisgraphy.service

## Interface UserService

- All Known Implementing Classes:
    UserManagerImpl

      public interface UserService

  Web Service interface so hierarchy of Universal and Generic Managers isn't carried through.

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `User` | `getUser(String userId)` Retrieves a user by userId.
    `User` | `getUserByUsername(String username)` Finds a user by their username.
    `List<User>` | `getUsers(User user)` Retrieves a list of users, filtering with parameters on a user object
    `void` | `removeUser(String userId)` Removes a user from the database by their userId
    `User` | `saveUser(User user)` Saves a user's information

- - ### Method Detail

    - #### getUser

          User getUser(String userId)

      Retrieves a user by userId. An exception is thrown if user not found
      Parameters:
        `userId` - the identifier for the user
      Returns:
        User

    - #### getUserByUsername

          User getUserByUsername(String username)
                                 throws org.springframework.security.userdetails.UsernameNotFoundException

      Finds a user by their username.
      Parameters:
        `username` - the user's username used to login
      Returns:
        User a populated user object
      Throws:
        `org.acegisecurity.userdetails.UsernameNotFoundException` - exception thrown when user not found
        `org.springframework.security.userdetails.UsernameNotFoundException`

    - #### getUsers

          List<User> getUsers(User user)

      Retrieves a list of users, filtering with parameters on a user object
      Parameters:
        `user` - parameters to filter on
      Returns:
        List

    - #### saveUser

          User saveUser(User user)
                        throws UserExistsException

      Saves a user's information
      Parameters:
        `user` - the user's information
      Returns:
        updated user
      Throws:
        `UserExistsException` - thrown when user already exists

    - #### removeUser

          void removeUser(String userId)

      Removes a user from the database by their userId
      Parameters:
        `userId` - the user's id

Copyright © 2015. All rights reserved.